#ifndef _KEYEX1_H_

#define _KEYEX1_H_

#include <openssl/dsa.h>
#include <openssl/engine.h>

int dh_gen_key_pair(BIGNUM **dh_pub_key, DH **dh_out);
int dh_gen_secret(DH *dh, BIGNUM *other_dh_pub_key, unsigned char *secret_out, int *secret_len);
//void send_public_key(BIGNUM *pub_key)
//DH *get_dh2048()
//BIGNUM *get_my_public_key(DSA *dsa)
//DSA *key_demote(const DSA *k)
DSA *key_load_private_pem(const char *filename, const char *passphrase);
void key_free(DSA *dsa);
DSA *key_new();

#endif // _KEYEX1_H_
